# All files / src/custom-nodes AbstractCustomNode.ts

100% Statements 9/9
100% Branches 0/0
100% Functions 1/1
100% Lines 8/8

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    571x
    1x

    1x

    1x

    3679x

    362x

    3661x

    3661x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from '../container/ServiceIdentifiers';

    import { ICustomNode } from '../interfaces/custom-nodes/ICustomNode';
    import { IOptions } from '../interfaces/options/IOptions';
    import { TStatement } from '../types/node/TStatement';

    import { NodeUtils } from '../node/NodeUtils';

    @injectable()
    export abstract class AbstractCustomNode implements ICustomNode {
        /**
         * @type {IOptions}
         */
        protected readonly options: IOptions;

        /**
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            this.options = options;
        }

        /**
         * @param args
         */
        public abstract initialize (...args: any[]): void;

        /**
         * @returns {string}
         */
        public getCode (): string {
            return NodeUtils.convertStructureToCode(this.getNode());
        }

        /**
         * @returns {TStatement[]}
         */
        public getNode (): TStatement[] {
            return this.getNodeStructure();
        }

        /**
         * @returns {TStatement[]}
         */
        protected getNodeStructure (): TStatement[] {
            return NodeUtils.convertCodeToStructure(this.getTemplate());
        }

        /**
         * @returns {string}
         */
        protected abstract getTemplate (): string;
    }